#include "RS232.h"


RS232::RS232 ( ) {
	
	    P3SEL |= BIT6 + BIT7; //P3.6 P3.7 = USART1

		ME2 |= UTXE1 + URXE1; //Sende und Empfangsmodul einschalten
		UCTL1 |= CHAR;        // 8 data bits, 1 stop bit, no parity (8N1)
		UTCTL1 |= SSEL1;      // SMCLK als UCLK festlegen
	//------------  Baudraten Einstellung  ---------------------
		UBR01 = 0x45;		  // 57600 baud aus 4MHz
		UBR11 = 0x00;		  // exakt 57553; Fehler: 0,8%
		UMCTL1 = 0xAA;		  // Korrektur der Division
	//------------  Baudraten Einstellung  ---------------------
		UCTL1 &= ~SWRST;      // USART freigeben
		IE2 |= URXIE1;        // RX-interrupt einschalten
		IFG2 &= ~URXIFG1;     // initales interrupt-flag loeschen
}



/**
 * Gibt den Stringbuffer ueber die RS232 Schnittstelle aus
 */

void RS232::flush ( ) {
	print(buffer, bufp - buffer);
	bufp = buffer;
}


void RS232::putc(char c){
	if(c == '\n'){
			while (!(IFG2 & UTXIFG1));
				    TXBUF1 = '\r';
		}
	while (!(IFG2 & UTXIFG1));
	    TXBUF1 = c;
}


void RS232::print(char* text, int length){
	  for(int i = 0; i < length; i++)
	  {
		  if(text[i] == '\n'){
			  while (!(IFG2 & UTXIFG1));
			          TXBUF1 = '\r';
		  }
		  	while (!(IFG2 & UTXIFG1));
	        TXBUF1 = text[i];
	  }
}




