#include "O_Stream.h"

O_Stream::O_Stream ( ) : num_mode(DEC) {
}

 void O_Stream::set_number_mode(number_modes nm){
		 num_mode = nm;
	 }

O_Stream& O_Stream::operator<< (char c ) {
	put(c);
	return *this;
} 

O_Stream& O_Stream::operator<< (int number ) {
	  if( (number < 0) && (num_mode == DEC) ){
			  number = number * (-1);
			  put('-');
			  process((unsigned long long) number);
	  }
	  else
	  {
		  process((unsigned long long) number);
	  }
	  return *this;
}


O_Stream& O_Stream::operator<< (unsigned int number ) {
	 process((unsigned long long)number);
	 return *this;
}


O_Stream& O_Stream::operator<< (long number ) {
 	if ( (number < 0) && (num_mode == DEC) ){
		      number = number * (-1);
		      put('-');
		  	  process((unsigned long long)number);
	 }
	 else
	 {
			   process((unsigned long long)number);
	 }  
	 return *this;
}

O_Stream& O_Stream::operator<< (unsigned long number ) {
	process((unsigned long long)number);
	return *this;
}

O_Stream& O_Stream::operator<< (long long number ) {
	if ( (number < 0) && (num_mode == DEC) ){
		      number = number * (-1);
		      put('-');
		  	  process((unsigned long long)number);
	}
	else
	{
			   process((unsigned long long)number);
	}  
		  
	return *this;
}


O_Stream& O_Stream::operator<< (unsigned long long number ) {
	process(number);
	return *this;
}

O_Stream& O_Stream::operator<< (void* pointer) {
		  number_modes temp = num_mode;
		  num_mode = HEX;
		  process((unsigned long long) (&pointer));
		  num_mode = temp;
		  return *this;
}


O_Stream& O_Stream::operator<< (char* text){
	while(*text)
		put(*text++);
	return *this;
}

 O_Stream& O_Stream::operator<< (O_Stream& (*fkt) (O_Stream&)) {
		  if(fkt == endl){
			  flush();
			  put('\n'); 
		  }else if(fkt == bin){
		 	  num_mode = BIN;
		  }else if(fkt == oct){
			  num_mode = OCT;
		  }else if(fkt == dec){
			  num_mode = DEC;
		  }else if(fkt == hex){
			  num_mode = HEX;
		  }else{
			  put('!'); put('#'); put('!');
		   }
		  
		  return *this;
	  }

/**
 * @param  number
 */
void O_Stream::process (unsigned long long number ) {
        int basis;
	    char temp[33];
	    char *p = temp;
	    unsigned long long i ;
		  
		  switch(O_Stream::num_mode){
			  case DEC:	basis = 10; break;
			  case HEX:	basis = 16; put('0'); put('x'); break;
			  case BIN:	basis = 2; break;
			  case OCT:	basis = 8; put('0'); break;
			  default: break;
		  }
		    if(number == 0) put('0');
		  	while(number){
				i = number % basis;
			    number = number / basis;
				if(i < 10)
					*p++ = ('0' + i);
				else	
					*p++ = ('a' + i - 10);
			}
			
			while(p > temp) put(*--p);
		
}

