
#ifndef STRINGBUFFER_H
#define STRINGBUFFER_H

#define BUFSIZE 16

/**
  * class Stringbuffer
  * Die Klasse Stringbuffer stellt einen Puffer fuer die Sammlung von Zeichen zur
  * Darstellung auf dem Bildschirm oder anderen Ausgabegeraeten bereit. Die Ausgabe
  * der Zeichen erfolgt, sobald der Puffer voll ist oder wenn explizit die Methode
  * flush() aufgerufen wird.  Da Stringbuffer geraeteunabhaengig sein soll, ist
  * flush() eine virtuelle Methode, die von den abgeleiteten Klassen definiert
  * werden muss.
  */ 

class Stringbuffer
{
public:	
  char buffer[BUFSIZE];
  int act_position;
  char * bufp;

  virtual void flush() = 0;
  Stringbuffer ( );
  void put (char c );
};

#endif // STRINGBUFFER_H
